class Authentifyd::RegistrationsController < Devise::RegistrationsController
  include Localyzed::LocalyzedController
  helper Authentifyd::ApplicationHelper

  layout Authentifyd.custom_layout || 'authentifyd/application'
  before_filter :define_body_class

  def new
    # Building the resource with information that MAY BE available from omniauth!
    build_resource(:email => session[:omniauth_email])
    render :new
  end

  def create
    build_resource

    if session[:omniauth] && @user.errors[:email][0] =~ /has already been taken/
      user = Authentifyd::User.find_by_email(@user.email)
      # Link Accounts - if via social connect
      return redirect_to link_accounts_url(user.id)
    end

    # normal processing
    super
    session[:omniauth] = nil unless @user.new_record?
  end

  def build_resource(*args)
    super

    @user.language = I18n.locale

    if session[:omniauth]
      @user.apply_omniauth(session[:omniauth])
      @user.valid?
    end
  end

  private

  def define_body_class
    @body_class = "authentifyd_registrations_#{action_name}"
  end

  alias_method :orig_after_inactive_sign_up_path_for, :after_inactive_sign_up_path_for
  def after_inactive_sign_up_path_for resource_or_scope
    new_user_session_url || orig_after_sign_up_path_for
  end


end
