require 'devise'
require "omniauth"
require 'omniauth-facebook'
require 'omniauth-twitter'
require 'omniauth-google-oauth2'
require "haml"
require 'localyzed'

require "authentifyd/engine"


module Authentifyd

  mattr_accessor :devise_config, :omniauth_config, 
    :mount_path, :path_prefix, :custom_head_snippet, 
    :custom_bottom_snippet, :top_navbar_snippet,
    :default_after_sign_in_path, :custom_layout,
    :facebook_config, :twitter_config, :google_config

  def self.devise_config
    (@@devise_config || {}).reverse_merge({
      :registrations_controller   => 'authentifyd/registrations',
      :sessions_controller        => 'authentifyd/sessions',
      :confirmations_controller   => 'authentifyd/confirmations',
      :passwords_controller       => 'authentifyd/passwords',
      :unlocks_controller         => 'authentifyd/unlocks'
    })
  end

  def self.mount_path
    @@mount_path ||= "/"
  end

  def self.embeddable_callback_path(_path)
    (Authentifyd.path_prefix ?  "#{Authentifyd.path_prefix}/" : '') + Authentifyd.mount_path + _path
  end
  
  def self.setup
    yield self
  end
end